

BirdShot = {};
mt_birdShot = {};
mt_birdShot.__index =BirdShot;
birdShot_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function BirdShot:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_birdShot);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


---- Functions --------------------------------------------------------------------------------

	

function BirdShot:InitializeGameObject( )
	self.scale = 1.3;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();


end
	
-----------------------------------------------------------------------------------------------------
	
function BirdShot:Update( birdShotPointer )


	local birdShotXV, birdShotYV  = GetLuaGameObjectXVAndYV(self.cppPointer);

	local birdShotX, birdShotY  = GetLuaGameObjectXAndY(self.cppPointer);

	birdShotX = birdShotX + birdShotXV;
	birdShotY = birdShotY + birdShotYV;

	if (birdShotX > self.playfieldMaxX) or (birdShotX < self.playfieldMinX ) or (birdShotY >self.playfieldMaxY ) or (birdShotY < self.playfieldMinY ) then
      SetLuaGameObjectIsDeadFlag( self.cppPointer, 1 );
	end;

	SetLuaGameObjectXandY( self.cppPointer, birdShotX, birdShotY );
		
	AnimateLuaGameObject( self.cppPointer );
	DrawLuaGameObject( self.cppPointer );


		
end

-----------------------------------------------------------------------------------------------------

	function PrepareForWaveStart ( birdShotPointer )
		SetLuaGameObjectXandY( birdShotPointer, 50, 50 );		
	end



---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
function BirdShot_Create(aCppPointer)
   temp = BirdShot:new(aCppPointer);
   birdShot_objects[aCppPointer] = temp;
end;
---------------------------------------------------------------------------

function BirdShot_Destroy(aCppPointer)
   birdShot_objects[aCppPointer] = nil;
end;
---------------------------------------------------------------------------


function BirdShot_InitializeGameObject(aCppPointer)
   PrintStringList("Calling BirdShot_InitializeGameObject");
   theBirdShot = birdShot_objects[aCppPointer];
   theBirdShot:InitializeGameObject();
end;



---------------------------------------------------------------------------
function BirdShot_Update(aCppPointer )
   PrintStringList("Calling BirdShot_Update");
   theBirdShot = birdShot_objects[aCppPointer];
   theBirdShot:Update(countdownTimer);
end;


