

Brain = {};
mt_brain = {};
mt_brain.__index = Brain;
brain_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

---------------------------------------------------------------------------
function Brain:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_brain);
end;

---------------------------------------------------------------------------


function Brain:RandomizeLuaGameObjectLocation( )
	
   
	local additionalOffset = 10;
	
	local gameObjectWidth = self.collisionBoxWidth + additionalOffset;
	local gameObjectHeight = self.collisionBoxHeight + additionalOffset;
		
	local minPlacementX = self.playfieldMinX + additionalOffset;
	local maxPlacementX = self.playfieldMaxX - gameObjectWidth;
	local minPlacementY = self.playfieldMinY + additionalOffset;
	local maxPlacementY = self.playfieldMaxY - gameObjectHeight;

	local playerX, playerY = GetPlayerXAndY();

   local x = 0;
   local y = 0;
   local distance = 0;

   repeat
--   PrintStringList(minPlacementX, maxPlacementX,minPlacementY , maxPlacementY);
      x = GenerateRandomNumber( minPlacementX, maxPlacementX );
      y = GenerateRandomNumber( minPlacementY, maxPlacementY );

       distance = GetDistanceBetweenTwoPoints( x,y, playerX, playerY);
   until distance >= 100;
	
--      PrintStringList("x = " .. x, "y = " .. y );
	SetLuaGameObjectXandY( self.cppPointer, x, y );		
end;

---------------------------------------------------------------------------


---------------------------------------------------------------------------


function Brain:HandleDeath() 
   PrintStringList("Calling Brain:HandleDeath");
	if( self.current_state == self.PROGRAMMING_PROG ) then
		PlaySound(FAMILYMEMBER_DIES_SOUND);
		
      local tempCppFamilyIcon = AddGameObject( FAMILY_ICON_TYPE, self.x, self.y );
      SetAnimation( tempCppFamilyIcon, 0);
      RemoveGameObject( self.prog_being_programmed.cppPointer  );
      self.prog_being_programmed = nil;
   end;

	self.current_state = DEAD;
   PrintStringList("Returning from Brain:HandleDeath");
end;


---------------------------------------------------------------------------

function Brain:ChaseGameObject( targetGameObject)
   PrintStringList("Calling Brain:ChaseGameObject");

   local x1 = 0;
   local y1 = 0;


--   targetGameObject.x, targetGameObject.y = 	GetLuaGameObjectXAndY( targetGameObject.cppPointer );
--   PrintStringList("Brain:ChaseGameObject, returned from GetLuaGameObjectXAndY");

	local  dx = 0;
	local  dy = 0;

	if( self.y > targetGameObject.y ) then
		dy = - self.BRAIN_SPEED;
--      PrintStringList("dy = " .. dy );
   end;


	if( self.y < targetGameObject.y ) then
		dy = self.BRAIN_SPEED;
--      PrintStringList("dy = " .. dy );
   end;

	if( self.x > targetGameObject.x ) then
		dx = - self.BRAIN_SPEED;
--      PrintStringList("dx = " .. dx );
   end;

	if( self.x < targetGameObject.x )  then
		dx = self.BRAIN_SPEED;
--      PrintStringList("dx = " .. dx );
   end;

   
--   PrintStringList("Brain:ChaseGameObject, calling GetAnimation()");
   local currentAnimation = GetAnimation( self.cppPointer );
--   PrintStringList("Brain:ChaseGameObject, returned from GetAnimation()");


   if( dx < 0 ) then
			if (currentAnimation ~= WEST) then
				SetAnimation( self.cppPointer,WEST);
         end
   elseif ( dx > 0 ) then
         if (currentAnimation ~= EAST) then
				SetAnimation( self.cppPointer,EAST);
         end;
   elseif ( dy < 0 ) then
			if (currentAnimation ~= NORTH) then
				SetAnimation( self.cppPointer,NORTH);
         end;
   elseif ( dy > 0 ) then
			if (currentAnimation ~= SOUTH) then
				SetAnimation( self.cppPointer,SOUTH);
         end;
   end;

--   PrintStringList("self.x  = " .. self.x );
--   PrintStringList("self.y  = " .. self.y );
   self.x = self.x + dx;
   self.y = self.y + dy;

	SetLuaGameObjectXandY( self.cppPointer, self.x, self.y );
   PrintStringList("Returning from  Brain:ChaseGameObject");

end;


---------------------------------------------------------------------------

function Brain:SelectNewTarget()
   PrintStringList("Calling Brain:SelectNewTarget");
	local numWomen = table.getn( familyMember_objects );

--   PrintStringList("numWomen = " .. numWomen );

	if( numWomen <= 0 ) then
		self.current_state = self.CHASING_PLAYER;
	else
		local target_familyMember_number = GenerateRandomNumber(1, numWomen );
      familyMemberTableEntry = familyMember_objects[target_familyMember_number];
      self.target_familyMember = familyMemberTableEntry["familyMember"];

		self.current_state = self.CHASING_FAMILYMEMBER;
   end;
   PrintStringList("Returning from  Brain:SelectNewTarget");
end;


---------------------------------------------------------------------------

function Brain:TargetFamilyMemberStillAlive()
   PrintStringList("Calling Brain:TargetFamilyMemberStillAlive");
	local stillAlive = false;

   if( self.target_familyMember == nil ) then
      return stillAlive;
   end;


   local nextTableEntry = {};
   for key, nextTableEntry in familyMember_objects do
      nextFamilyMember = nextTableEntry["familyMember"];
      if( nextFamilyMember == self.target_familyMember) then
         stillAlive = true;
      end;
   end;

   PrintStringList("Returning from Brain:TargetFamilyMemberStillAlive");
	return stillAlive;

end;

---------------------------------------------------------------------------

function Brain:HandleProgKilled()
	self.prog_being_programmed = NULL;
	self:SelectNewTarget();

end;


---------------------------------------------------------------------------

function Brain:HandleChasingPlayer()
   PrintStringList("Calling Brain:HandleChasingPlayer");
   thePlayer = {};
   thePlayer.x, thePlayer.y = GetPlayerXAndY();
   PrintStringList("thePlayer.x = " .. thePlayer.x  );
   PrintStringList("thePlayer.y = " .. thePlayer.y  );
   self:ChaseGameObject(thePlayer);
   PrintStringList("Returning from Brain:HandleChasingPlayer");
end;


---------------------------------------------------------------------------

function Brain:AddProg(progX, progY)
   PrintStringList("Calling Brain:AddProg");
   local addedProgCppPointer = AddGameObject(PROG_TYPE, progX , progY );
	self.prog_being_programmed = prog_objects[addedProgCppPointer];
   self.prog_being_programmed.brain_programming_me = self;
   PrintStringList("Returning from  Brain:AddProg");
end;

---------------------------------------------------------------------------

function Brain:HandleChasingFamilyMember()
   PrintStringList("Calling Brain:HandleChasingFamilyMember");

   local stillAlive = self:TargetFamilyMemberStillAlive();
   PrintStringList("Return from calling self:TargetFamilyMemberStillAlive()");
   if( stillAlive ) then
      PrintStringList("stillAlive = true" );
   else
      PrintStringList("stillAlive = false" );
   end;


	if( stillAlive ~= true) then
		self:SelectNewTarget();
		if( self.current_state == self.CHASING_PLAYER) then
			self:HandleChasingPlayer();
			return;
      end;
   end;

   self.target_familyMember.x, self.target_familyMember.y = GetLuaGameObjectXAndY( self.target_familyMember.cppPointer ); 
	self:ChaseGameObject(self.target_familyMember);

	local distanceToFamilyMember = GetDistanceBetweenTwoPoints(
         self.x, self.y, self.target_familyMember.x, self.target_familyMember.y );

   PrintStringList( "distanceToFamilyMember = " .. distanceToFamilyMember );
	if(distanceToFamilyMember <= 20) then
		self.current_state = self.PROGRAMMING_PROG;
		self.programming_timer = 100;
      self:AddProg(self.target_familyMember.x, self.target_familyMember.y);
      RemoveGameObject( self.target_familyMember.cppPointer );
--      self.target_familyMember = nil;
   end;


   PrintStringList("Returning from Brain:HandleChasingFamilyMember");
end;


---------------------------------------------------------------------------

function Brain:HandleProgrammingProg()
   PrintStringList("Calling Brain:HandleProgrammingProg");
	self.programming_timer = self.programming_timer - 1;
	if(self.programming_timer <= 0 ) then

      self.prog_being_programmed.moving = true;
		self.prog_being_programmed = nil;
		self:SelectNewTarget();
   end;

--	Animate_BOB(&GetBOB());
--	Draw();
   PrintStringList("Returning from Brain:HandleProgrammingProg");
end;


---------------------------------------------------------------------------

function Brain:HandleShooting()
	self.shot_timer = self.shot_timer - 1;
	if(self.shot_timer <= 0) then
		self.shot_timer = GenerateRandomNumber(100,250);
      AddGameObject(BRAIN_SHOT_TYPE, self.x + 10 , self.y + 10 );      
   end;
end;


---------------------------------------------------------------------------

function Brain:Update( )
   PrintStringList("Calling Brain:Update");

   self.x, self.y = 	GetLuaGameObjectXAndY(self.cppPointer );

	self:HandleShooting();

   if( self.current_state == self.CHASING_FAMILYMEMBER ) then
      self:HandleChasingFamilyMember();
   elseif( self.current_state == self.CHASING_PLAYER ) then
      self:HandleChasingPlayer();
   elseif( self.current_state == self.PROGRAMMING_PROG ) then
      self:HandleProgrammingProg();
   end;



	AnimateLuaGameObject( self.cppPointer );
	DrawLuaGameObject( self.cppPointer );

end



---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


function Brain:InitializeGameObject()
--   PrintStringList("Calling Brain:InitializeGameObject");
	self.scale = 1.3;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();

	self.CHASING_FAMILYMEMBER = 0;
	self.PROGRAMMING_PROG = 1;
	self.CHASING_PLAYER = 2;
	self.DEAD = 3;

   self.BRAIN_SPEED = 0.5;

	self.current_state = self.CHASING_FAMILYMEMBER;

   self.target_familyMember = nil;
   self.prog_being_programmed = nil;
   self.shot_timer = GenerateRandomNumber(100,250);


end;

---------------------------------------------------------------------------

function Brain:PrepareForWaveStart ()

   self.beamInSpacing = 14;
   self.beamInSpacingDecrementTimerMAX = 2;
   self.beamInSpacingDecrementTimer = self.beamInSpacingDecrementTimerMAX;
   self.startBeamTimerValue = GenerateRandomNumber(20,70);
   self.widthOrHeightFlag = GenerateRandomNumber(0,1);

   self:RandomizeLuaGameObjectLocation();
end

---------------------------------------------------------------------------

function Brain:PreWaveStartUpdate(  countdownTimer)
	if countdownTimer <= self.startBeamTimerValue then
      self.beamInSpacingDecrementTimer  = self.beamInSpacingDecrementTimer -1 ;
      if( self.beamInSpacingDecrementTimer <= 0) then
         self.beamInSpacingDecrementTimer = self.beamInSpacingDecrementTimerMAX;
         self.beamInSpacing = self.beamInSpacing - 2;
         if( self.beamInSpacing < 0 ) then
            self.beamInSpacing = 0;
         end;
      end;
      ExplodingDrawLuaGameObject( self.cppPointer, self.beamInSpacing, self.widthOrHeightFlag  );
	end;
end;



---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
function Brain_GetLuaObjectFromCppPointer( aCppPointer )
   return brain_objects[aCppPointer];
end;

function Brain_Create(aCppPointer)
   temp = Brain:new(aCppPointer);
   brain_objects[aCppPointer] = temp;
end;


---------------------------------------------------------------------------

function Brain_Destroy(aCppPointer)
   brain_objects[aCppPointer] = nil;
end;

---------------------------------------------------------------------------


function Brain_InitializeGameObject(aCppPointer)
   theBrain = brain_objects[aCppPointer];
   theBrain:InitializeGameObject();
end;

---------------------------------------------------------------------------

function Brain_PrepareForWaveStart(aCppPointer)
   theBrain = brain_objects[aCppPointer];
   theBrain:PrepareForWaveStart();
end;

---------------------------------------------------------------------------

function Brain_PreWaveStartUpdate(aCppPointer, countdownTimer)
--   PrintStringList("Calling Brain_PreWaveStartUpdate");
   theBrain = brain_objects[aCppPointer];
   theBrain:PreWaveStartUpdate(countdownTimer);
end;

---------------------------------------------------------------------------
function Brain_Update(aCppPointer )
--   PrintStringList("Calling Brain_Update");
   theBrain = brain_objects[aCppPointer];
   theBrain:Update(countdownTimer);
end;




