

BrainShot = {};
mt_brainShot = {};
mt_brainShot.__index =BrainShot;
brainShot_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function BrainShot_Create(aCppPointer)
   temp = BrainShot:new(aCppPointer);
   brainShot_objects[aCppPointer] = temp;
end;
---------------------------------------------------------------------------
function BrainShot:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_brainShot);
end;



---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function BrainShot:PickNewState()
	self.state_timer = 10;
	local  r = GenerateRandomNumber(0,100);
	if( r > 90 )  then
		self.current_state = self.ZIGGING_UP;
		return;
   end;
	if( r > 80 ) then
		self.current_state = self.ZIGGING_DOWN;
		return;
   end;
	if( r > 70 ) then 
		self.current_state = self.ZIGGING_LEFT;
		return;
   end;
	if( r > 60 ) then
		self.current_state = self.ZIGGING_RIGHT;
		return;
   end;


	self.current_state = self.PURSUING_PLAYER;

end;




---- Functions --------------------------------------------------------------------------------

	

function BrainShot:InitializeGameObject( )
	self.scale = 1;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
	self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();


   self.ZIGGING_UP = 0;
	self.ZIGGING_DOWN = 1;
	self.ZIGGING_LEFT = 2;
	self.ZIGGING_RIGHT = 3;
   self.PURSUING_PLAYER = 4;

   self.BRAIN_SHOT_SPEED = 3;


   self.current_state = self.PURSUING_PLAYER;
   self.state_timer = 10;

   self.previousPositions = {};
   table.setn( self.previousPositions, 0 );
   local testResult = table.getn( self.previousPositions );
end
	

-----------------------------------------------------------------------------------------------------

function BrainShot:HandlePursuingPlayer()

   local xv = 0;
   local yv = 0;

   playerX, playerY = GetPlayerXAndY();

	if( self.x > playerX) then
		xv = - self.BRAIN_SHOT_SPEED;
   end;

	if( self.x < playerX ) then
		xv = self.BRAIN_SHOT_SPEED;
   end;

	if( self.y > playerY) then
		yv = - self.BRAIN_SHOT_SPEED;
   end;

	if( self.y  < playerY) then
		yv = self.BRAIN_SHOT_SPEED;
   end;

   return xv,yv;

end;


function BrainShot:Draw()
   DirectDrawLockSurface();
   

   
   self:DrawShotElement( self.x, self.y, 240 );

	local numPreviousShots = table.getn( self.previousPositions );

   local index = 1;

   while( index <= numPreviousShots ) 
   do
      local nextEntry = self.previousPositions[index];
      self:DrawShotElement( nextEntry[1], nextEntry[2], 94 );
      index = index + 1;
   end;

   DirectDrawUnlockSurface();
end;

function BrainShot:DrawShotElement(x,y, shotColor)



--   DirectDrawDrawPixel(x + 1, y-1, shotColor );
--   DirectDrawDrawPixel(x,        y-1, shotColor );
--   DirectDrawDrawPixel(x - 1,   y-1, shotColor );

--   DirectDrawDrawPixel(x + 1,  y, shotColor );
--   DirectDrawDrawPixel(x,         y, shotColor );
--   DirectDrawDrawPixel(x - 1,    y, shotColor );

--   DirectDrawDrawPixel(x + 1,  y+1, shotColor );
--   DirectDrawDrawPixel(x,         y+1, shotColor );
--   DirectDrawDrawPixel(x - 1,    y+1, shotColor );


   local alpha = 0;
   local red = 245;
   local green = 245;
   local blue = 245;   
 

   DirectDrawDrawPixel32(x + 1, y-1, alpha, red, green, blue );
   DirectDrawDrawPixel32(x,        y-1, alpha, red, green, blue );
   DirectDrawDrawPixel32(x - 1,   y-1, alpha, red, green, blue );

   DirectDrawDrawPixel32(x + 1,  y, alpha, red, green, blue );
   DirectDrawDrawPixel32(x,         y, alpha, red, green, blue );
   DirectDrawDrawPixel32(x - 1,    y, alpha, red, green, blue );

   DirectDrawDrawPixel32(x + 1,  y+1, alpha, red, green, blue );
   DirectDrawDrawPixel32(x,         y+1, alpha, red, green, blue );
   DirectDrawDrawPixel32(x - 1,    y+1, alpha, red, green, blue );




end;


-----------------------------------------------------------------------------------------------------

function BrainShot:TrackPreviousPositions()

	local numPreviousShots = table.getn( self.previousPositions );
   
	if( numPreviousShots >= 10 ) then
      table.remove( self.previousPositions , 1 );
   end;

   table.insert( self.previousPositions, {self.x, self.y } );

   

end;


-----------------------------------------------------------------------------------------------------
	
function BrainShot:Update( brainShotPointer )


	self.x,self.y  = GetLuaGameObjectXAndY(self.cppPointer);
	self.collisionBoxX, self.collisionBoxY  = GetLuaGameObjectCollisionBoxXAndY(self.cppPointer );		

	self.state_timer = self.state_timer - 1;
	if(self.state_timer <= 0 ) then
		self:PickNewState();
   end;

   local yv = 0;
   local xv = 0;

	if ( self.current_state == self.ZIGGING_UP ) then
		yv = - self.BRAIN_SHOT_SPEED;
   elseif ( self.current_state ==  self.ZIGGING_DOWN) then
		yv = self.BRAIN_SHOT_SPEED;
   elseif ( self.current_state == self.ZIGGING_LEFT) then
		xv = - self.BRAIN_SHOT_SPEED;
   elseif ( self.current_state == self.ZIGGING_RIGHT) then
		xv = self.BRAIN_SHOT_SPEED;
   elseif ( self.current_state == self.PURSUING_PLAYER) then
		xv, yv = self:HandlePursuingPlayer();
   end;


   self.x = self.x + xv;
   self.y = self.y + yv;


	if( WasCollisionWithLeftRightWall(self) ) then
      self.x = self.x - xv;
   end;

	if( WasCollisionWithUpDownWall(self)) then
      self.y = self.y - yv;
   end;


	SetLuaGameObjectXandY( self.cppPointer, self.x, self.y );

   self:Draw();
--	AnimateLuaGameObject( self.cppPointer );
--	DrawLuaGameObject( self.cppPointer );

   self:TrackPreviousPositions();

		
end

-----------------------------------------------------------------------------------------------------


---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

---------------------------------------------------------------------------

function BrainShot_Create(aCppPointer)
   temp = BrainShot:new(aCppPointer);
   brainShot_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------

function BrainShot_Destroy(aCppPointer)
   brainShot_objects[aCppPointer] = nil;
end;

---------------------------------------------------------------------------


function BrainShot_InitializeGameObject(aCppPointer)
   PrintStringList("Calling BrainShot_InitializeGameObject");
   theBrainShot = brainShot_objects[aCppPointer];
   theBrainShot:InitializeGameObject();
end;

---------------------------------------------------------------------------
function BrainShot_Update(aCppPointer )
   PrintStringList("Calling BrainShot_Update");
   theBrainShot = brainShot_objects[aCppPointer];
   theBrainShot:Update(countdownTimer);
end;


