
------------------------------------------------------------------

function HandleGruntKilled ( cppObjectPointer1, cppObjectPointer2, scoreIncrement )

	IncrementScore( scoreIncrement );
	PlaySound( GRUNT_DIES_SOUND );

   local x = 0;
   local y = 0;
   x,y = GetLuaGameObjectXAndY( cppObjectPointer2 );


   local tempCppExplodingGrunt = AddGameObject( EXPLODING_GRUNT_TYPE, x, y );

   local theExplodingGrunt = FindExplodingGruntFromPointer( tempCppExplodingGrunt );
   theExplodingGrunt.widthOrHeightFlag = 0;

   local shotAnimation = GetAnimation( cppObjectPointer1 );
   LogLevel1("shotAnimation = " .. shotAnimation);

   if( shotAnimation == 0 ) then
      theExplodingGrunt.widthOrHeightFlag = 1;
   end;

	return true, true;
end

------------------------------------------------------------------

function HandleTankKilled ( cppObjectPointer1, cppObjectPointer2, scoreIncrement )
	IncrementScore( scoreIncrement );
	PlaySound( GRUNT_DIES_SOUND );

   local x = 0;
   local y = 0;
   x,y = GetLuaGameObjectXAndY( cppObjectPointer2 );


   local tempCppExplodingTank = AddGameObject( EXPLODING_TANK_TYPE, x, y );

   local theExplodingTank = FindExplodingTankFromPointer( tempCppExplodingTank );
   theExplodingTank.widthOrHeightFlag = 0;

   local shotAnimation = GetAnimation( cppObjectPointer1 );
   LogLevel1("shotAnimation = " .. shotAnimation);

   if( shotAnimation == 0 ) then
      theExplodingTank.widthOrHeightFlag = 1;
   end;

	return true, true;
end

------------------------------------------------------------------

function HandleBirdKilled ( cppObjectPointer1, cppObjectPointer2, scoreIncrement )
	IncrementScore( scoreIncrement );
	PlaySound( GRUNT_DIES_SOUND );

   local x = 0;
   local y = 0;
   x,y = GetLuaGameObjectXAndY( cppObjectPointer2 );


   local tempCppExplodingBird = AddGameObject( EXPLODING_BIRD_TYPE, x, y );

   local theExplodingBird = FindExplodingBirdFromPointer( tempCppExplodingBird );
   theExplodingBird.widthOrHeightFlag = 0;

   local shotAnimation = GetAnimation( cppObjectPointer1 );
   LogLevel1("shotAnimation = " .. shotAnimation);

   if( shotAnimation == 0 ) then
      theExplodingBird.widthOrHeightFlag = 1;
   end;

	return true, true;
end


------------------------------------------------------------------

function RemoveBothPlaySoundAndIncrementScore ( cppObjectPointer1, cppObjectPointer2, scoreIncrement )
	IncrementScore( scoreIncrement );
	PlaySound( GRUNT_DIES_SOUND );
	return true, true;
end

------------------------------------------------------------------

function RemoveBothAndIncrementScore ( cppObjectPointer1, cppObjectPointer2, scoreIncrement )
	IncrementScore( scoreIncrement );
	return true, true;
end

------------------------------------------------------------------
function HandleHulkHitsElectrode( cppObjectPointer1, cppObjectPointer2, scoreIncrement )
   return false, true;
end;

------------------------------------------------------------------

function HandleFamilyMemberHitsElectrode( cppObjectPointer1, cppObjectPointer2, scoreIncrement )
   local theFamilyMember = FindFamilyMemberFromPointer( cppObjectPointer1 );
   theFamilyMember.ReverseDirection( theFamilyMember );

   return false,false;
end;

function PlayerKilled(cppObjectPointer1, cppObjectPointer2, scoreIncrement)
	NotifyPlayerDied();
	return false,false;
end;


------------------------------------------------------------------

CurrentFamilyScore = 1000;


------------------------------------------------------------------

function FamilyMemberPickedUp(cppPointerFamily )


	PlaySound( FAMILY_MEMBER_PICKED_UP_SOUND);

   local x = 0;
   local y = 0;
   x,y = GetLuaGameObjectXAndY( cppPointerFamily );

   local tempCppFamilyIcon = AddGameObject( FAMILY_ICON_TYPE, x, y );
   IncrementScore( CurrentFamilyScore );   
   local animation = CurrentFamilyScore / 1000;
   SetAnimation( tempCppFamilyIcon, animation);
   if( CurrentFamilyScore < 5000 ) then
      CurrentFamilyScore = CurrentFamilyScore + 1000;
   end 

  
	return true;

end;

------------------------------------------------------------------

function BrainDeathHandler(cppObjectPointer1, cppObjectPointer2, scoreIncrement )
   local theBrain = Brain_GetLuaObjectFromCppPointer(cppObjectPointer2);
   theBrain:HandleDeath();
	IncrementScore( scoreIncrement );
	PlaySound( GRUNT_DIES_SOUND );
   local x = 0;
   local y = 0;
   x,y = GetLuaGameObjectXAndY( cppObjectPointer2 );


   local tempCppExplodingBrain = AddGameObject( EXPLODING_BRAIN_TYPE, x, y );

   local theExplodingBrain = FindExplodingBrainFromPointer( tempCppExplodingBrain );
   theExplodingBrain.widthOrHeightFlag = 0;

   local shotAnimation = GetAnimation( cppObjectPointer1 );
--   LogLevel1("shotAnimation = " .. shotAnimation);

   if( shotAnimation == 0 ) then
      theExplodingBrain.widthOrHeightFlag = 1;
   end;


	return true, true;

end;


------------------------------------------------------------------

function ProgDeathHandler(cppObjectPointer1, cppObjectPointer2, scoreIncrement )
--   LogLevel1("Calling Prog:ProgDeathHandler");

   local theProg = Prog_GetLuaObjectFromCppPointer(cppObjectPointer2);
   theProg:HandleDeath();
	IncrementScore( scoreIncrement );
	PlaySound( GRUNT_DIES_SOUND );
--   LogLevel1("Returning from Prog:ProgDeathHandler");
	return true, true;

end;


------------------------------------------------------------------

function FamilyMemberHitByHulkHandler(cppObjectPointer1, cppObjectPointer2, scoreIncrement )
   local theFamilyMember = FindFamilyMemberFromPointer( cppObjectPointer1 );
   theFamilyMember.x, theFamilyMember.y = GetLuaGameObjectXAndY( cppObjectPointer1 );
   local tempCppFamilyIcon = AddGameObject( FAMILY_ICON_TYPE, theFamilyMember.x, theFamilyMember.y );
   PlaySound( FAMILYMEMBER_DIES_SOUND );
   SetAnimation( tempCppFamilyIcon, 0);
   return true, false;
end;


------------------------------------------------------------------


function NudgeHulk(cppObjectPointer1, cppObjectPointer2, scoreIncrement )
   

   local NUDGE_AMOUNT = 5;

   local theHulk = Hulk_GetLuaObjectFromCppPointer(cppObjectPointer2);
   theHulk.x, theHulk.y = GetLuaGameObjectXAndY( cppObjectPointer2 );

   local shot_xv, shot_yv  = GetLuaGameObjectXVAndYV(cppObjectPointer1);
--   playfieldMinX, playfieldMaxX, playfieldMinY, playfieldMaxY = GetPlayfieldLimits();
   hulkWidth, hulkHeight = GetLuaGameObjectCollisionBoxInfo( cppObjectPointer2 );

--   local offset = 5;
   
   local dx = 0;
   local dy = 0;

   if( shot_xv > 0 ) then
   	dx = NUDGE_AMOUNT;
   end;

   if( shot_xv < 0 ) then
   	dx = -NUDGE_AMOUNT;
   end;


   if( shot_yv > 0 ) then
   	dy = NUDGE_AMOUNT;
   end;

   if( shot_yv < 0 ) then
   	dy = -NUDGE_AMOUNT;
   end;
   
   theHulk.x = theHulk.x + dx;
   theHulk.y = theHulk.y + dy;

   if ( WasCollisionWithLeftRightWall(theHulk) ) then
      theHulk.x = theHulk.x -dx;

   end;

   if ( WasCollisionWithUpDownWall(theHulk) ) then
	theHulk.y = theHulk.y - dy;
   end;
   
   
   SetLuaGameObjectXandY( cppObjectPointer2, theHulk.x, theHulk.y );
   PlaySound( HULK_HIT_SOUND);

   return true,false;
end;

------------------------------------------------------------------

function OriginalNudgeHulk(cppObjectPointer1, cppObjectPointer2, scoreIncrement )
   

   local NUDGE_AMOUNT = 5;
--   local theShot = PlayerShot_GetLuaObjectFromCppPointer(cppObjectPointer1);
   local theHulk = Hulk_GetLuaObjectFromCppPointer(cppObjectPointer2);
   theHulk.x, theHulk.y = GetLuaGameObjectXAndY( cppObjectPointer2 );

	local shot_xv, shot_yv  = GetLuaGameObjectXVAndYV(cppObjectPointer1);
	playfieldMinX, playfieldMaxX, playfieldMinY, playfieldMaxY = GetPlayfieldLimits();
   hulkWidth, hulkHeight = GetLuaGameObjectCollisionBoxInfo( cppObjectPointer2 );

   local offset = 5;

	if( shot_xv > 0 ) then
		local proposed_new_x_position = theHulk.x + NUDGE_AMOUNT;
		if( proposed_new_x_position <= (playfieldMaxX -10 - hulkWidth) ) then
         theHulk.x = proposed_new_x_position;
      end;

   end;

	if( shot_xv < 0 ) then
		local proposed_new_x_position = theHulk.x - NUDGE_AMOUNT;
		if( proposed_new_x_position + 5 >playfieldMinX  + offset) then
         theHulk.x = proposed_new_x_position;
      end;

   end;

	if( shot_yv > 0 ) then
		local proposed_new_y_position = theHulk.y + NUDGE_AMOUNT;
		if( proposed_new_y_position < (playfieldMaxY - 10 - hulkHeight)) then
--			aHulk->SetY( aHulk->GetY() + NUDGE_AMOUNT);
         theHulk.y = proposed_new_y_position;
      end;

   end;

	if( shot_yv < 0 ) then
		local proposed_new_y_position = theHulk.y - NUDGE_AMOUNT;
		if( proposed_new_y_position + 5 >playfieldMinY + offset) then
--			aHulk->SetY( float(proposed_new_y_position ));
         theHulk.y = proposed_new_y_position;
      end;

   end;
   
   SetLuaGameObjectXandY( cppObjectPointer2, theHulk.x, theHulk.y );
   PlaySound( HULK_HIT_SOUND);

   return true,false;
end;

------------------------------------------------------------------

------------------------------------------------------------------
------------------------------------------------------------------

function RegisterCollisionChecks()
	
	AddCollisionCheckAndHandler(
			WOMAN_TYPE,  -- Player Shot
			ELECTRODE_TYPE_1,   -- Grunt
			0,  -- 12 points
			"HandleFamilyMemberHitsElectrode");


	AddCollisionCheckAndHandler(
			WOMAN_TYPE,  -- Player Shot
			ELECTRODE_TYPE_2,   -- Grunt
			0,  -- 12 points
			"HandleFamilyMemberHitsElectrode");


	AddCollisionCheckAndHandler(
			MAN_TYPE,  -- Player Shot
			ELECTRODE_TYPE_1,   -- Grunt
			0,  -- 12 points
			"HandleFamilyMemberHitsElectrode");


	AddCollisionCheckAndHandler(
			MAN_TYPE,  -- Player Shot
			ELECTRODE_TYPE_2,   -- Grunt
			0,  -- 12 points
			"HandleFamilyMemberHitsElectrode");


	AddCollisionCheckAndHandler(
			MIKEY_TYPE,  -- Player Shot
			ELECTRODE_TYPE_1,   -- Grunt
			0,  -- 12 points
			"HandleFamilyMemberHitsElectrode");


	AddCollisionCheckAndHandler(
			MIKEY_TYPE,  -- Player Shot
			ELECTRODE_TYPE_2,   -- Grunt
			0,  -- 12 points
			"HandleFamilyMemberHitsElectrode");


-----------------------------------------------------

	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			GRUNT_TYPE,   -- Grunt
			100,  -- 12 points
			"HandleGruntKilled");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			GRUNT_TYPE,   -- Grunt
			100,  -- 12 points
			"HandleGruntKilled");



	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			CIRCLE_TYPE,   -- Circle
			1000,  -- 1000  points
			"RemoveBothPlaySoundAndIncrementScore");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			CIRCLE_TYPE,   -- Circle
			1000,  -- 1000  points
			"RemoveBothPlaySoundAndIncrementScore");


	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			BIRD_TYPE,   -- Bird
			150,  -- 12 points
			"HandleBirdKilled");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			BIRD_TYPE,   -- Bird
			150,  -- 12 points
			"HandleBirdKilled");


	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			BIRD_SHOT_TYPE,   -- Bird Shot
			75,  -- 12 points
			"RemoveBothPlaySoundAndIncrementScore");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			BIRD_SHOT_TYPE,   -- Bird Shot
			75,  -- 12 points
			"RemoveBothPlaySoundAndIncrementScore");







	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			TANK_TYPE,
			200,  -- points
			"HandleTankKilled");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			TANK_TYPE,
			200,  -- points
			"HandleTankKilled");



	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			SQUARE_TYPE,
			1000,  -- points
			"RemoveBothPlaySoundAndIncrementScore");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			SQUARE_TYPE,
			1000,  -- points
			"RemoveBothPlaySoundAndIncrementScore");


	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			BRAIN_TYPE,
			500,  -- points
			"BrainDeathHandler");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			BRAIN_TYPE,
			500,  -- points
			"BrainDeathHandler");




	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			PROG_TYPE,
			100,  -- points
			"ProgDeathHandler");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			PROG_TYPE,
			100,  -- points
			"ProgDeathHandler");


	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			BRAIN_SHOT_TYPE,
			25,  -- points
			"RemoveBothPlaySoundAndIncrementScore");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			BRAIN_SHOT_TYPE,
			25,  -- points
			"RemoveBothPlaySoundAndIncrementScore");


	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			ELECTRODE_TYPE_1,
			50,  -- points
			"RemoveBothPlaySoundAndIncrementScore");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			ELECTRODE_TYPE_1,
			50,  -- points
			"RemoveBothPlaySoundAndIncrementScore");


	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			ELECTRODE_TYPE_2,
			50,  -- points
			"RemoveBothPlaySoundAndIncrementScore");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			ELECTRODE_TYPE_2,
			50,  -- points
			"RemoveBothPlaySoundAndIncrementScore");



	AddCollisionCheckAndHandler(
			PLAYER_SHOT_TYPE,  -- Player Shot
			HULK_TYPE,
			0,  -- points
			"NudgeHulk");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE,  -- Player Shield
			HULK_TYPE,
			0,  -- points
			"RemoveBothPlaySoundAndIncrementScore");


-----------------------------------------------------

	AddCollisionCheckAndHandler(
			GRUNT_TYPE, 
			ELECTRODE_TYPE_1,
			100,  -- points
			"HandleGruntKilled");

	AddCollisionCheckAndHandler(
			GRUNT_TYPE, 
			ELECTRODE_TYPE_2,
			100,  -- points
			"HandleGruntKilled");







	AddCollisionCheckAndHandler(
			WOMAN_TYPE,  -- Player Shot
			HULK_TYPE,
			0,  -- points
			"FamilyMemberHitByHulkHandler");


	AddCollisionCheckAndHandler(
			HULK_TYPE,
         ELECTRODE_TYPE_1,
			0,  -- points
			"HandleHulkHitsElectrode");

	AddCollisionCheckAndHandler(
			HULK_TYPE,
         ELECTRODE_TYPE_2,
			0,  -- points
			"HandleHulkHitsElectrode");




	AddCollisionCheckAndHandler(
			MAN_TYPE,  -- Player Shot
			HULK_TYPE,
			0,  -- points
			"FamilyMemberHitByHulkHandler");



	AddCollisionCheckAndHandler(
			MIKEY_TYPE,  -- Player Shot
			HULK_TYPE,
			0,  -- points
			"FamilyMemberHitByHulkHandler");



	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
         BRAIN_TYPE, -- Grunt
			0,
			"PlayerKilled");

	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
         PROG_TYPE, -- Grunt
			0,
			"PlayerKilled");


	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
         GRUNT_TYPE, -- Grunt
			0,
			"PlayerKilled");

	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			CIRCLE_TYPE, -- Circle
			0,
			"PlayerKilled");



	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			SQUARE_TYPE, -- Circle
			0,
			"PlayerKilled");


	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			BIRD_TYPE, -- Bird
			0,
			"PlayerKilled");


	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			BIRD_SHOT_TYPE, -- BirdShot
			0,
			"PlayerKilled");

	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			TANK_TYPE, 
			0,
			"PlayerKilled");


	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			TANK_SHOT_TYPE, 
			0,
			"PlayerKilled");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE, -- Player Shield
			TANK_SHOT_TYPE, 
			0,
			"RemoveBothPlaySoundAndIncrementScore");


	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			WOMAN_TYPE, 
			0,
			"FamilyMemberPickedUp");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE, -- Player Shield
			WOMAN_TYPE, 
			0,
			"FamilyMemberPickedUp");
			
			

	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			MAN_TYPE, 
			0,
			"FamilyMemberPickedUp");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE, -- Player Shield
			MAN_TYPE, 
			0,
			"FamilyMemberPickedUp");



	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			MIKEY_TYPE, 
			0,
			"FamilyMemberPickedUp");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE, -- Player Shield
			MIKEY_TYPE, 
			0,
			"FamilyMemberPickedUp");



	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			BRAIN_SHOT_TYPE, 
			0,
			"PlayerKilled");
	AddCollisionCheckAndHandler(
			PLAYER_SHIELD_TYPE, -- Player Shield
			BRAIN_SHOT_TYPE, 
			0,
			"RemoveBothPlaySoundAndIncrementScore");
			
			


	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			HULK_TYPE, 
			0,
			"PlayerKilled");


	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			ELECTRODE_TYPE_1, 
			0,
			"PlayerKilled");


	AddCollisionCheckAndHandler(
			PLAYER_TYPE, -- Player
			ELECTRODE_TYPE_2, 
			0,
			"PlayerKilled");

			

	
end;




