

Electrode = {};
mt_electrode = {};
mt_electrode.__index =Electrode;
electrode_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function Electrode_Create(aCppPointer)
   temp = Electrode:new(aCppPointer);
   electrode_objects[aCppPointer] = temp;
   local numElectrodes = table.getn( electrode_objects );

--   LogLevel1("In Electrode_Create - numElectrodes = " .. numElectrodes );

end;
---------------------------------------------------------------------------
function Electrode:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_electrode);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


---- Functions --------------------------------------------------------------------------------


function Electrode:RandomizeLuaGameObjectLocation( )
	
   
	local additionalOffset = 10;
	
	local gameObjectWidth = self.collisionBoxWidth + additionalOffset;
	local gameObjectHeight = self.collisionBoxHeight + additionalOffset;
		
	local minPlacementX = self.playfieldMinX + additionalOffset;
	local maxPlacementX = self.playfieldMaxX - gameObjectWidth;
	local minPlacementY = self.playfieldMinY + additionalOffset;
	local maxPlacementY = self.playfieldMaxY - gameObjectHeight;

	local playerX, playerY = GetPlayerXAndY();

   local x = 0;
   local y = 0;
   local distance = 0;

   repeat
--   PrintStringList(minPlacementX, maxPlacementX,minPlacementY , maxPlacementY);
      x = GenerateRandomNumber( minPlacementX, maxPlacementX );
      y = GenerateRandomNumber( minPlacementY, maxPlacementY );

       distance = GetDistanceBetweenTwoPoints( x,y, playerX, playerY);
   until distance >= 100;
	
--      PrintStringList("x = " .. x, "y = " .. y );
	SetLuaGameObjectXandY( self.cppPointer, x, y );		
end;

	

function Electrode:InitializeGameObject( )
	self.scale = 1;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
    self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();

end
	
-----------------------------------------------------------------------------------------------------
	
function Electrode:Update( electrodePointer )

	AnimateLuaGameObject( self.cppPointer );
	DrawLuaGameObject( self.cppPointer );

		
end

-----------------------------------------------------------------------------------------------------

function Electrode:PrepareForWaveStart ()
   self:RandomizeLuaGameObjectLocation();
end

---------------------------------------------------------------------------

function Electrode:PreWaveStartUpdate(  countdownTimer)
	if countdownTimer <= 70 then
      DrawLuaGameObject( self.cppPointer );
	end;
end;



---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

---------------------------------------------------------------------------

function Electrode_Create(aCppPointer)
   temp = Electrode:new(aCppPointer);
   electrode_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------

function Electrode_Destroy(aCppPointer)
   electrode_objects[aCppPointer] = nil;
end;

---------------------------------------------------------------------------


function Electrode_InitializeGameObject(aCppPointer)
   PrintStringList("Calling Electrode_InitializeGameObject");
   theElectrode = electrode_objects[aCppPointer];
   theElectrode:InitializeGameObject();
end;

function Electrode_PrepareForWaveStart(aCppPointer)
   theElectrode = electrode_objects[aCppPointer];
   theElectrode:PrepareForWaveStart();
end;

---------------------------------------------------------------------------

function Electrode_PreWaveStartUpdate(aCppPointer, countdownTimer)
--   PrintStringList("Calling Electrode_PreWaveStartUpdate");
   theElectrode = electrode_objects[aCppPointer];
   theElectrode:PreWaveStartUpdate(countdownTimer);
end;


---------------------------------------------------------------------------
function Electrode_Update(aCppPointer )
   PrintStringList("Calling Electrode_Update");
   theElectrode = electrode_objects[aCppPointer];
   theElectrode:Update(countdownTimer);
end;


