

ExplodingBird = {};
mt_explodingBird = {};
mt_explodingBird.__index =ExplodingBird;
explodingBird_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function ExplodingBird:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_explodingBird);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


---- Functions --------------------------------------------------------------------------------

	

function ExplodingBird:InitializeGameObject( )
	self.scale = 1;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();
	
	self.countdown_timer = 7;
   self.explosionIncrementTimerMAX = 1;   
   self.explosionIncrementTimer =  self.explosionIncrementTimerMAX;
   self.explosionSpacing = 0;
   self.widthOrHeightFlag = 0;

end
	
-----------------------------------------------------------------------------------------------------
	
function ExplodingBird:Update( explodingBirdPointer )

   self.countdown_timer = self.countdown_timer - 1;
   if( self.countdown_timer <= 0) then
      SetLuaGameObjectIsDeadFlag( self.cppPointer, 1);
   end;

	AnimateLuaGameObject( self.cppPointer );

	ExplodingDrawLuaGameObject( self.cppPointer,self.explosionSpacing , self.widthOrHeightFlag );

   self.explosionIncrementTimer = self.explosionIncrementTimer - 1;
   if( self.explosionIncrementTimer <= 0 ) then
      self.explosionIncrementTimer =  self.explosionIncrementTimerMAX;
      self.explosionSpacing = self.explosionSpacing + 2;
   end;

--	DrawLuaGameObject( self.cppPointer );


		
end

-----------------------------------------------------------------------------------------------------




---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
function FindExplodingBirdFromPointer (cppPointer )
   return explodingBird_objects[cppPointer] ;
end;


function ExplodingBird_Create(aCppPointer)
   temp = ExplodingBird:new(aCppPointer);
   explodingBird_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------
function ExplodingBird_Destroy(aCppPointer)
   explodingBird_objects[aCppPointer] = nil;
end;
---------------------------------------------------------------------------

function ExplodingBird_InitializeGameObject(aCppPointer)
   PrintStringList("Calling ExplodingBird_InitializeGameObject");
   theExplodingBird = explodingBird_objects[aCppPointer];
   theExplodingBird:InitializeGameObject();
end;



---------------------------------------------------------------------------
function ExplodingBird_Update(aCppPointer )
   PrintStringList("Calling ExplodingBird_Update");
   theExplodingBird = explodingBird_objects[aCppPointer];
   theExplodingBird:Update(countdownTimer);
end;


