

ExplodingBrain = {};
mt_explodingBrain = {};
mt_explodingBrain.__index =ExplodingBrain;
explodingBrain_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function ExplodingBrain:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_explodingBrain);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


---- Functions --------------------------------------------------------------------------------

	

function ExplodingBrain:InitializeGameObject( )
	self.scale = 1.3;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();
	
	self.countdown_timer = 7;
   self.explosionIncrementTimerMAX = 1;   
   self.explosionIncrementTimer =  self.explosionIncrementTimerMAX;
   self.explosionSpacing = 0;
   self.widthOrHeightFlag = 0;

end
	
-----------------------------------------------------------------------------------------------------
	
function ExplodingBrain:Update( explodingBrainPointer )

   self.countdown_timer = self.countdown_timer - 1;
   if( self.countdown_timer <= 0) then
      SetLuaGameObjectIsDeadFlag( self.cppPointer, 1);
   end;

	AnimateLuaGameObject( self.cppPointer );

	ExplodingDrawLuaGameObject( self.cppPointer,self.explosionSpacing , 0 );
	ExplodingDrawLuaGameObject( self.cppPointer,self.explosionSpacing , 1 );

   self.explosionIncrementTimer = self.explosionIncrementTimer - 1;
   if( self.explosionIncrementTimer <= 0 ) then
      self.explosionIncrementTimer =  self.explosionIncrementTimerMAX;
      self.explosionSpacing = self.explosionSpacing + 2;
   end;

--	DrawLuaGameObject( self.cppPointer );


		
end

-----------------------------------------------------------------------------------------------------




---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
function FindExplodingBrainFromPointer (cppPointer )
   return explodingBrain_objects[cppPointer] ;
end;


function ExplodingBrain_Create(aCppPointer)
   temp = ExplodingBrain:new(aCppPointer);
   explodingBrain_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------
function ExplodingBrain_Destroy(aCppPointer)
   explodingBrain_objects[aCppPointer] = nil;
end;
---------------------------------------------------------------------------

function ExplodingBrain_InitializeGameObject(aCppPointer)
   PrintStringList("Calling ExplodingBrain_InitializeGameObject");
   theExplodingBrain = explodingBrain_objects[aCppPointer];
   theExplodingBrain:InitializeGameObject();
end;



---------------------------------------------------------------------------
function ExplodingBrain_Update(aCppPointer )
   PrintStringList("Calling ExplodingBrain_Update");
   theExplodingBrain = explodingBrain_objects[aCppPointer];
   theExplodingBrain:Update(countdownTimer);
end;


