

ExplodingHulk = {};
mt_explodingHulk = {};
mt_explodingHulk.__index =ExplodingHulk;
explodingHulk_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function ExplodingHulk:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_explodingHulk);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


---- Functions --------------------------------------------------------------------------------

	

function ExplodingHulk:InitializeGameObject( )
	self.scale = 1;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();
	
	self.countdown_timer = 7;
   self.explosionIncrementTimerMAX = 1;   
   self.explosionIncrementTimer =  self.explosionIncrementTimerMAX;
   self.explosionSpacing = 0;
   self.widthOrHeightFlag = 0;

end
	
-----------------------------------------------------------------------------------------------------
	
function ExplodingHulk:Update( explodingHulkPointer )

   self.countdown_timer = self.countdown_timer - 1;
   if( self.countdown_timer <= 0) then
      SetLuaGameObjectIsDeadFlag( self.cppPointer, 1);
   end;

	AnimateLuaGameObject( self.cppPointer );

	ExplodingDrawLuaGameObject( self.cppPointer,self.explosionSpacing , self.widthOrHeightFlag );

   self.explosionIncrementTimer = self.explosionIncrementTimer - 1;
   if( self.explosionIncrementTimer <= 0 ) then
      self.explosionIncrementTimer =  self.explosionIncrementTimerMAX;
      self.explosionSpacing = self.explosionSpacing + 2;
   end;

--	DrawLuaGameObject( self.cppPointer );


		
end

-----------------------------------------------------------------------------------------------------




---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
function FindExplodingHulkFromPointer (cppPointer )
   return explodingHulk_objects[cppPointer] ;
end;


function ExplodingHulk_Create(aCppPointer)
   temp = ExplodingHulk:new(aCppPointer);
   explodingHulk_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------
function ExplodingHulk_Destroy(aCppPointer)
   explodingHulk_objects[aCppPointer] = nil;
end;
---------------------------------------------------------------------------

function ExplodingHulk_InitializeGameObject(aCppPointer)
   PrintStringList("Calling ExplodingHulk_InitializeGameObject");
   theExplodingHulk = explodingHulk_objects[aCppPointer];
   theExplodingHulk:InitializeGameObject();
end;



---------------------------------------------------------------------------
function ExplodingHulk_Update(aCppPointer )
   PrintStringList("Calling ExplodingHulk_Update");
   theExplodingHulk = explodingHulk_objects[aCppPointer];
   theExplodingHulk:Update(countdownTimer);
end;


