

FamilyMember = {};
mt_familyMember = {};
mt_familyMember.__index = FamilyMember;
familyMember_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
function FamilyMember:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_familyMember);
end;

---------------------------------------------------------------------------


function FamilyMember:IsOppositeDirection( direction1, direction2)
	
   local isOpposite = false;


   if( direction1 == EAST) then
		if( direction2 == WEST) then
         isOpposite = true;
		end;
	elseif ( direction1 == WEST ) then
		if( direction2 == EAST) then
			isOpposite = true;
       end;
   elseif ( direction1 == NORTH ) then
		if( direction2 == SOUTH) then
			isOpposite = true;
      end;
   elseif ( direction1 == SOUTH ) then
		if( direction2 == NORTH) then 
			isOpposite = true;
      end;
   end;

	return isOpposite;

end;

---------------------------------------------------------------------------
function FamilyMember:ReverseDirection()

	if( self.motionDirection == EAST) then
	  self:SetMotionDirection(WEST);
   elseif( self.motionDirection == WEST) then
	  self:SetMotionDirection(EAST);      
   elseif( self.motionDirection == NORTH) then
	  self:SetMotionDirection(SOUTH);      
   elseif( self.motionDirection == SOUTH) then
	  self:SetMotionDirection(NORTH);      
   end;
end;

---------------------------------------------------------------------------

function FamilyMember:GetRandomDirection()
   local randomNumber = GenerateRandomNumber(0,3);
   if( randomNumber == 0 ) then
      return NORTH;
   end;

   if( randomNumber == 1 ) then
      return EAST;
   end;

   if( randomNumber == 2 ) then
      return SOUTH;
   end;

   if( randomNumber == 3 ) then
      return WEST;
   end;


end;

---------------------------------------------------------------------------

function FamilyMember:SelectNewDirection()
--   PrintStringList("Calling FamilyMember:SelectNewDirection");
	local oldDirection = self.motionDirection;

--	self.motionDirection = GenerateRandomNumber(0,3);
	local proposedNewDirection = self:GetRandomDirection();

	while( self:IsOppositeDirection( oldDirection, proposedNewDirection) )
   do
      proposedNewDirection = self:GetRandomDirection();
   end;
	
	self:SetMotionDirection( proposedNewDirection );
	self.motionCountdownTimer = GenerateRandomNumber(25, 60 );
--   PrintStringList("Exiting FamilyMember:SelectNewDirection");
end;


---------------------------------------------------------------------------


function FamilyMember:InitializeGameObject()
--   PrintStringList("Calling FamilyMember:InitializeGameObject");
	self.scale = 1.3;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();


   self.motionCountdownTimer = 0;
   self:SetMotionDirection( EAST) 
--   self.motionDirection = 0;


--   self. WOMAN_MOTION_DIRECTION_RIGHT = 0;
--   self. WOMAN_MOTION_DIRECTION_DOWN = 1;
--   self. WOMAN_MOTION_DIRECTION_LEFT = 2;
--   self. WOMAN_MOTION_DIRECTION_UP = 3;
   self. MAX_WOMAN_MOTION_DIRECTION_DISTANCE = 10;
   self.WOMAN_SPEED  = 0.5;

   SetAnimationSpeed(self.cppPointer, 8);

end;

---------------------------------------------------------------------------

function FamilyMember:PrepareForWaveStart ()
--   LogLevel1("Calling FamilyMember:PrepareForWaveStart");
   CurrentFamilyScore = 1000;
   RandomizeLuaGameObjectLocation(self);
--   LogLevel1("Returning from FamilyMember:PrepareForWaveStart");
end

---------------------------------------------------------------------------

function FamilyMember:PreWaveStartUpdate(  countdownTimer)

	if countdownTimer <= 70 then
--      DrawLuaGameObject( self.cppPointer );
      self:Update();
	end;
end;

---------------------------------------------------------------------------

function FamilyMember:SetMotionDirection( newDirection )
   self.motionDirection = newDirection;
	if (GetAnimation(self.cppPointer) ~= newDirection) then
      SetAnimation(self.cppPointer, newDirection );
   end;

end;

---------------------------------------------------------------------------
function FamilyMember:Update( )

	self.motionCountdownTimer = self.motionCountdownTimer - 1;
	if(self.motionCountdownTimer <= 0) then
		self:SelectNewDirection();
   end;

	local dx = 0;
	local dy = 0;
   

   if( self.motionDirection == EAST ) then
		dx = self.WOMAN_SPEED;
--		if (GetAnimation(self.cppPointer) ~= EAST) then
--         SetAnimation(self.cppPointer, EAST );
--      end;
   elseif (self.motionDirection ==  WEST ) then
		dx = -self.WOMAN_SPEED;
--		if (GetAnimation(self.cppPointer) ~= WEST) then
--			SetAnimation(self.cppPointer,WEST);
--      end;
   elseif   (self.motionDirection == NORTH) then
		dy = -self.WOMAN_SPEED;
--		if (GetAnimation(self.cppPointer) ~= NORTH) then
--			SetAnimation(self.cppPointer,NORTH);
--      end;
   elseif 	 (self.motionDirection == SOUTH ) then
		dy = self.WOMAN_SPEED;
--		if (GetAnimation(self.cppPointer) ~= SOUTH) then
--			SetAnimation(self.cppPointer,SOUTH);
--      end;
   end;
   
   self.collisionBoxX, self.collisionBoxY  = GetLuaGameObjectCollisionBoxXAndY(self.cppPointer );	
   self.x, self.y = GetLuaGameObjectXAndY(self.cppPointer);
   self.x = self.x + dx;
   self.y = self.y + dy;
   
   self.collisionBoxWidth, self.collisionBoxHeight = GetLuaGameObjectCollisionBoxInfo( self.cppPointer );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();


	if ( WasCollisionWithLeftRightWall(self) ) then
      self.x = self.x - dx;
		self:SelectNewDirection();
   end;

	if ( WasCollisionWithUpDownWall(self) ) then
      self.y = self.y - dy;
		self:SelectNewDirection();
   end;


	SetLuaGameObjectXandY( self.cppPointer, self.x, self.y );
		
	AnimateLuaGameObject( self.cppPointer );
	DrawLuaGameObject( self.cppPointer );

end


---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------



function FindFamilyMemberIndexFromPointer( aCppPointer )

--   local foundFamilyMember = nil;
   local numWomen = table.getn( familyMember_objects );
   local foundIndex = nil;
   local index = 1;
   local done = false;
   while( (index <= numWomen) and (done == false) ) do
         local nextTableEntry = familyMember_objects[index];
            if( nextTableEntry["cppPointer"] == aCppPointer ) then
               foundIndex = index;
               done = true;
            end;
         index = index + 1;
   end;

   return foundIndex;
   
end;

---------------------------------------------------------------------------
function FindFamilyMemberFromPointer( aCppPointer )
   local index = FindFamilyMemberIndexFromPointer( aCppPointer );
   local foundFamilyMember = nil;
   if( index ~= nil ) then
      local nextTableEntry = familyMember_objects[index];
         foundFamilyMember = nextTableEntry["familyMember"];
   end;

   return foundFamilyMember;
end;


---------------------------------------------------------------------------

function FamilyMember_Create(aCppPointer)
   newFamilyMemberTable = FamilyMember:new(aCppPointer);
   newFamilyMemberTableEntry = { cppPointer = aCppPointer, familyMember = newFamilyMemberTable };
   local numWomen = table.getn( familyMember_objects );
   numWomen = numWomen + 1;
   familyMember_objects[numWomen] = newFamilyMemberTableEntry;
   table.setn( familyMember_objects, numWomen );
   

	local numWomen = table.getn( familyMember_objects );

   PrintStringList("FamilyMember_Create:   numWomen = " .. numWomen );

   local anEntry = familyMember_objects[1];
   local aFamilyMember = anEntry["familyMember"];

--   if( aFamilyMember == nill ) then
--      PrintStringList("was nil");
   --else
--      PrintStringList("was not nil");
--   end;

end;


---------------------------------------------------------------------------
function FamilyMember_Destroy(aCppPointer)

	local numWomen = table.getn( familyMember_objects );

   PrintStringList("FamilyMember_Destroy, before removal:   numWomen = " .. numWomen );

   local foundFamilyMemberIndex = FindFamilyMemberIndexFromPointer( aCppPointer );
   if( foundFamilyMemberIndex ~= nil ) then
      table.remove( familyMember_objects, foundFamilyMemberIndex );
   end;

	numWomen = table.getn( familyMember_objects );

   PrintStringList("FamilyMember_Destroy, after removal:   numWomen = " .. numWomen );

end;


---------------------------------------------------------------------------
function FamilyMember_InitializeGameObject(aCppPointer)
--   theFamilyMember = familyMember_objects[aCppPointer];
   theFamilyMember = FindFamilyMemberFromPointer( aCppPointer );
   theFamilyMember:InitializeGameObject();
end;

---------------------------------------------------------------------------

function FamilyMember_PrepareForWaveStart(aCppPointer)
--   theFamilyMember = familyMember_objects[aCppPointer];
   theFamilyMember = FindFamilyMemberFromPointer( aCppPointer );
   theFamilyMember:PrepareForWaveStart();
end;

---------------------------------------------------------------------------

function FamilyMember_PreWaveStartUpdate(aCppPointer, countdownTimer)
--   PrintStringList("Calling FamilyMember_PreWaveStartUpdate");
--   theFamilyMember = familyMember_objects[aCppPointer];
   theFamilyMember = FindFamilyMemberFromPointer( aCppPointer );
   theFamilyMember:PreWaveStartUpdate(countdownTimer);
end;

---------------------------------------------------------------------------
function FamilyMember_Update(aCppPointer )
--   PrintStringList("Calling FamilyMember_Update");
--   theFamilyMember = familyMember_objects[aCppPointer];
   theFamilyMember = FindFamilyMemberFromPointer( aCppPointer );
   theFamilyMember:Update(countdownTimer);
end;




