
---------------------------------------------------------------------------

EAST     =   0;
NEAST   =   1 ;
NORTH  =   2;
NWEST  =  3;
WEST    =  4;
SWEST  =  5;
SOUTH  =  6;
SEAST   =  7;


---------------------------------------------------------------------------

function CheckForCollisionWithElectrode( object )
--   LogLevel1("Calling CheckForCollisionWithElectrode");	

   local numElectrodes = table.getn( electrode_objects );

--   LogLevel1("numElectrodes = " .. numElectrodes );


   for key, nextElectrode in electrode_objects do
--      LogLevel1("Calling C++ CheckForCollision");
      local wasCollision = CheckForCollision ( object.cppPointer , nextElectrode.cppPointer );
--      LogLevel1("Returned from C++ CheckForCollision");
      if( wasCollision == true ) then
--         LogLevel1("Returning true from  CheckForCollisionWithElectrode");	
         return true;
      end;

   end;

--   LogLevel1("Returning false from  CheckForCollisionWithElectrode");	

   return false;

end;

---------------------------------------------------------------------------

function RandomizeLuaGameObjectLocation( self )
--   LogLevel1("Calling RandomizeLuaGameObjectLocation");	
   
	local additionalOffset = 10;
	
	local gameObjectWidth = self.collisionBoxWidth + additionalOffset;
	local gameObjectHeight = self.collisionBoxHeight + additionalOffset;
		
	local minPlacementX = self.playfieldMinX + additionalOffset;
	local maxPlacementX = self.playfieldMaxX - gameObjectWidth;
	local minPlacementY = self.playfieldMinY + additionalOffset;
	local maxPlacementY = self.playfieldMaxY - gameObjectHeight;

	local playerX, playerY = GetPlayerXAndY();

   local distance = 0;
   local collisionWithElectrode = false;

   repeat
      self.x = GenerateRandomNumber( minPlacementX, maxPlacementX );
      self.y = GenerateRandomNumber( minPlacementY, maxPlacementY );

      distance = GetDistanceBetweenTwoPoints( self.x,self.y, playerX, playerY);
      SetLuaGameObjectXandY( self.cppPointer, self.x, self.y );		
      collisionWithElectrode = CheckForCollisionWithElectrode(self);
   until ( (distance >= 100 ) and (collisionWithElectrode ~= true) );

--   LogLevel1("Returning from RandomizeLuaGameObjectLocation");	
end;

---------------------------------------------------------------------------








