PlayerShot = {};
mt_playerShot = {};
mt_playerShot.__index =PlayerShot;
playerShot_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

---------------------------------------------------------------------------
function PlayerShot:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_playerShot);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


function PlayerShot:InitializeGameObject()
   PrintStringList("Calling PlayerShot:InitializeGameObject");
	self.scale = 1;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth  -3;
	self.collisionBoxHeight = self.bitmapHeight -3;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();

end
	
-----------------------------------------------------------------------------------------------------
	
function PlayerShot:Update( )
   PrintStringList("Calling PlayerShot:Update");
	local playerShotXV, playerShotYV  = GetLuaGameObjectXVAndYV(self.cppPointer);

	local playerShotX, playerShotY  = GetLuaGameObjectXAndY(self.cppPointer);

	playerShotX = playerShotX + playerShotXV;
	playerShotY = playerShotY + playerShotYV;

	if (playerShotX > self.playfieldMaxX) or (playerShotX < self.playfieldMinX ) or (playerShotY >self.playfieldMaxY ) or (playerShotY < self.playfieldMinY ) then
      SetLuaGameObjectIsDeadFlag( self.cppPointer, 1 );
	end;

	SetLuaGameObjectXandY( self.cppPointer, playerShotX, playerShotY );
		
	AnimateLuaGameObject( self.cppPointer );
	DrawLuaGameObject( self.cppPointer );
		
end


---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function PlayerShot_GetLuaObjectFromCppPointer( aCppPointer )
   return playerShot_objects[aCppPointer];
end;


function PlayerShot_Create(aCppPointer)
   temp = PlayerShot:new(aCppPointer);
   playerShot_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------
function PlayerShot_Destroy(aCppPointer)
   playerShot_objects[aCppPointer] = nil;
end;


---------------------------------------------------------------------------


function PlayerShot_InitializeGameObject(aCppPointer)
   PrintStringList("Calling PlayerShot_InitializeGameObject");
   thePlayerShot = playerShot_objects[aCppPointer];
   thePlayerShot:InitializeGameObject();
end;



---------------------------------------------------------------------------
function PlayerShot_Update(aCppPointer )
   PrintStringList("Calling PlayerShot_Update");
   thePlayerShot = playerShot_objects[aCppPointer];
   thePlayerShot:Update(countdownTimer);
end;

