

Prog = {};
mt_prog = {};
mt_prog.__index = Prog;
prog_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

---------------------------------------------------------------------------
function Prog:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_prog);
end;
---------------------------------------------------------------------------


function Prog:RandomizeLuaGameObjectLocation( )
	
   
	local additionalOffset = 10;
	
	local gameObjectWidth = self.collisionBoxWidth + additionalOffset;
	local gameObjectHeight = self.collisionBoxHeight + additionalOffset;
		
	local minPlacementX = self.playfieldMinX + additionalOffset;
	local maxPlacementX = self.playfieldMaxX - gameObjectWidth;
	local minPlacementY = self.playfieldMinY + additionalOffset;
	local maxPlacementY = self.playfieldMaxY - gameObjectHeight;

	local playerX, playerY = GetPlayerXAndY();

   local x = 0;
   local y = 0;
   local distance = 0;

   repeat
--   PrintStringList(minPlacementX, maxPlacementX,minPlacementY , maxPlacementY);
      x = GenerateRandomNumber( minPlacementX, maxPlacementX );
      y = GenerateRandomNumber( minPlacementY, maxPlacementY );

       distance = GetDistanceBetweenTwoPoints( x,y, playerX, playerY);
   until distance >= 100;
	
--      PrintStringList("x = " .. x, "y = " .. y );
	SetLuaGameObjectXandY( self.cppPointer, x, y );		
end;

---------------------------------------------------------------------------

function Prog:HandleDeath()
	if(self.moving == false) then
		self.brain_programming_me:HandleProgKilled();
		self.brain_programming_me = nil;
   end;
end;

---------------------------------------------------------------------------

function Prog:IsOppositeDirection( direction1, direction2)
	
   local isOpposite = false;


   if( direction1 == self.PROG_MOTION_DIRECTION_RIGHT) then
		if( direction2 == self.PROG_MOTION_DIRECTION_LEFT) then
         isOpposite = true;
		end;
	elseif ( direction1 == self.PROG_MOTION_DIRECTION_LEFT ) then
		if( direction2 == self.PROG_MOTION_DIRECTION_RIGHT) then
			isOpposite = true;
       end;
   elseif ( direction1 == self.PROG_MOTION_DIRECTION_UP ) then
		if( direction2 == self.PROG_MOTION_DIRECTION_DOWN) then
			isOpposite = true;
      end;
   elseif ( direction1 == self.PROG_MOTION_DIRECTION_DOWN ) then
		if( direction2 == self.PROG_MOTION_DIRECTION_UP) then 
			isOpposite = true;
      end;
   end;

	return isOpposite;

end;


---------------------------------------------------------------------------

function Prog:SelectNewDirection()

	local oldDirection = self.motionDirection;

	self.motionDirection = GenerateRandomNumber(0,3);

	while( self:IsOppositeDirection( oldDirection, self.motionDirection) )
	do
		self.motionDirection = GenerateRandomNumber(0,3);
	end;
	self.motionCountdownTimer = GenerateRandomNumber(20, self.MAX_PROG_MOTION_DIRECTION_DISTANCE);

end;

---------------------------------------------------------------------------


function Prog:InitializeGameObject()
--   PrintStringList("Calling Prog:InitializeGameObject");
	self.scale = 2 * 1.3;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
   self.collisionBoxWidth = self.bitmapWidth * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();


   self.moving = false;
   self.motionDirection = 0;

   self.PROG_MOTION_DIRECTION_RIGHT = 0;
   self.PROG_MOTION_DIRECTION_DOWN = 1;
   self.PROG_MOTION_DIRECTION_LEFT = 2;
   self.PROG_MOTION_DIRECTION_UP = 3;
   self.MAX_PROG_MOTION_DIRECTION_DISTANCE = 70;
   self.motionCountdownTimer = nil;
   self.PROG_SPEED = 4;
   self.brain_programming_me = nil;



	self:SelectNewDirection();
end;


---------------------------------------------------------------------------
function Prog:Update( )
--   PrintStringList("Calling Prog:Update");

	self.collisionBoxX, self.collisionBoxY  = GetLuaGameObjectCollisionBoxXAndY(self.cppPointer );	
	
	if( self.moving == false) then
      AnimateLuaGameObject( self.cppPointer );
      DrawLuaGameObject( self.cppPointer );
		return;
   end;

	self.motionCountdownTimer = self.motionCountdownTimer - 1;
	if(self.motionCountdownTimer <= 0) then
		self:SelectNewDirection();
   end;

	local dx = 0;
	local dy = 0;
   

	self.x, self.y  = GetLuaGameObjectXAndY(self.cppPointer );

   if( self.motionDirection == self.PROG_MOTION_DIRECTION_RIGHT ) then
		dx = self.PROG_SPEED;
--		if (GetAnimation(self.cppPointer) ~= EAST) then
--         SetAnimation(self.cppPointer, EAST );
--      end;
   elseif (self.motionDirection ==  self.PROG_MOTION_DIRECTION_LEFT ) then
		dx = -self.PROG_SPEED;
--		if (GetAnimation(self.cppPointer) ~= WEST) then
--			SetAnimation(self.cppPointer,WEST);
--      end;
   elseif   (self.motionDirection == self.PROG_MOTION_DIRECTION_UP) then
		dy = -self.PROG_SPEED;
--		if (GetAnimation(self.cppPointer) ~= NORTH) then
--			SetAnimation(self.cppPointer,NORTH);
--      end;
   elseif 	 (self.motionDirection == self.PROG_MOTION_DIRECTION_DOWN ) then
		dy = self.PROG_SPEED;
--		if (GetAnimation(self.cppPointer) ~= SOUTH) then
--			SetAnimation(self.cppPointer,SOUTH);
--      end;
   end;

   self.x, self.y = GetLuaGameObjectXAndY(self.cppPointer);
   self.x = self.x + dx;
   self.y = self.y + dy;
   
   self.collisionBoxWidth, self.collisionBoxHeight = GetLuaGameObjectCollisionBoxInfo( self.cppPointer );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();


	if ( WasCollisionWithLeftRightWall(self) ) then
      self.x = self.x - dx;
		self:SelectNewDirection();
   end;

	if ( WasCollisionWithUpDownWall(self) ) then
      self.y = self.y - dy;
		self:SelectNewDirection();
   end;


	SetLuaGameObjectXandY( self.cppPointer, self.x, self.y );
		
	AnimateLuaGameObject( self.cppPointer );
	DrawLuaGameObject( self.cppPointer );



end



---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


function Prog_GetLuaObjectFromCppPointer( aCppPointer )
   return prog_objects[aCppPointer];
end;

function Prog_Create(aCppPointer)
   temp = Prog:new(aCppPointer);
   prog_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------

function Prog_Destroy(aCppPointer)
   prog_objects[aCppPointer] = nil;
end;

---------------------------------------------------------------------------

function Prog_InitializeGameObject(aCppPointer)
   theProg = prog_objects[aCppPointer];
   theProg:InitializeGameObject();
end;

---------------------------------------------------------------------------

function Prog_PrepareForWaveStart(aCppPointer)
   theProg = prog_objects[aCppPointer];
   theProg:PrepareForWaveStart();
end;

---------------------------------------------------------------------------

function Prog_PreWaveStartUpdate(aCppPointer, countdownTimer)
--   PrintStringList("Calling Prog_PreWaveStartUpdate");
   theProg = prog_objects[aCppPointer];
   theProg:PreWaveStartUpdate(countdownTimer);
end;

---------------------------------------------------------------------------
function Prog_Update(aCppPointer )
--   PrintStringList("Calling Prog_Update");
   theProg = prog_objects[aCppPointer];
   theProg:Update(countdownTimer);
end;




