

TadHead = {};
mt_tadHead = {};
mt_tadHead.__index =TadHead;
tadHead_objects = {};

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

function TadHead_Create(aCppPointer)
   temp = TadHead:new(aCppPointer);
   tadHead_objects[aCppPointer] = temp;
   local numTadHeads = table.getn( tadHead_objects );

--   LogLevel1("In TadHead_Create - numTadHeads = " .. numTadHeads );

end;
---------------------------------------------------------------------------
function TadHead:new(aCppPointer)
   return setmetatable({cppPointer = aCppPointer},mt_tadHead);
end;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------


---- Functions --------------------------------------------------------------------------------


function TadHead:RandomizeLuaGameObjectLocation( )
	
   
	local additionalOffset = 10;
	
	local gameObjectWidth = self.collisionBoxWidth + additionalOffset;
	local gameObjectHeight = self.collisionBoxHeight + additionalOffset;
		
	local minPlacementX = self.playfieldMinX + additionalOffset;
	local maxPlacementX = self.playfieldMaxX - gameObjectWidth;
	local minPlacementY = self.playfieldMinY + additionalOffset;
	local maxPlacementY = self.playfieldMaxY - gameObjectHeight;

	local playerX, playerY = GetPlayerXAndY();

   local x = 0;
   local y = 0;
   local distance = 0;

   repeat
--   PrintStringList(minPlacementX, maxPlacementX,minPlacementY , maxPlacementY);
      x = GenerateRandomNumber( minPlacementX, maxPlacementX );
      y = GenerateRandomNumber( minPlacementY, maxPlacementY );

       distance = GetDistanceBetweenTwoPoints( x,y, playerX, playerY);
   until distance >= 100;
	
--      PrintStringList("x = " .. x, "y = " .. y );
	SetLuaGameObjectXandY( self.cppPointer, x, y );		
end;

	

function TadHead:InitializeGameObject( )
	self.scale = 2;
	SetLuaGameObjectScale( self.cppPointer, self.scale );
	self.bitmapWidth, self.bitmapHeight = GetLuaGameObjectBitmapSize( self.cppPointer );
    self.collisionBoxWidth = self.bitmapWidth  * self.scale;
	self.collisionBoxHeight = self.bitmapHeight * self.scale;
	SetLuaGameObjectCollisionBoxInfo( self.cppPointer, self.collisionBoxWidth, self.collisionBoxHeight, 0 );
	self.playfieldMinX, self.playfieldMaxX, self.playfieldMinY, self.playfieldMaxY = GetPlayfieldLimits();

end
	
-----------------------------------------------------------------------------------------------------
	
function TadHead:Update( tadHeadPointer )

	AnimateLuaGameObject( self.cppPointer );
	DrawLuaGameObject( self.cppPointer );

		
end

-----------------------------------------------------------------------------------------------------

function TadHead:PrepareForWaveStart ()
   self:RandomizeLuaGameObjectLocation();
end

---------------------------------------------------------------------------

function TadHead:PreWaveStartUpdate(  countdownTimer)
	if countdownTimer <= 70 then
      DrawLuaGameObject( self.cppPointer );
	end;
end;



---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

---------------------------------------------------------------------------

function TadHead_Create(aCppPointer)
   temp = TadHead:new(aCppPointer);
   tadHead_objects[aCppPointer] = temp;
end;

---------------------------------------------------------------------------

function TadHead_Destroy(aCppPointer)
   tadHead_objects[aCppPointer] = nil;
end;

---------------------------------------------------------------------------


function TadHead_InitializeGameObject(aCppPointer)
   PrintStringList("Calling TadHead_InitializeGameObject");
   theTadHead = tadHead_objects[aCppPointer];
   theTadHead:InitializeGameObject();
end;

function TadHead_PrepareForWaveStart(aCppPointer)
   theTadHead = tadHead_objects[aCppPointer];
   theTadHead:PrepareForWaveStart();
end;

---------------------------------------------------------------------------

function TadHead_PreWaveStartUpdate(aCppPointer, countdownTimer)
--   PrintStringList("Calling TadHead_PreWaveStartUpdate");
   theTadHead = tadHead_objects[aCppPointer];
   theTadHead:PreWaveStartUpdate(countdownTimer);
end;


---------------------------------------------------------------------------
function TadHead_Update(aCppPointer )
   PrintStringList("Calling TadHead_Update");
   theTadHead = tadHead_objects[aCppPointer];
   theTadHead:Update(countdownTimer);
end;


